const net = require('net');
const url = require('url');

const mode = process.env.MODE || 'PORT';
const host = process.env.HOST || '127.0.0.1';
const port = process.env.PORT || 4444;
const remotePort = process.env.REMOTE_PORT || 1111;
const destination = url.parse(process.env.DESTINATION || 'http://localhost:1234');

const destinationConnections = {};

const proxyConnection = net.createConnection(port, host, (err)=>{
  console.log({err})
});
proxyConnection.setNoDelay(true)

proxyConnection.write(JSON.stringify({port: remotePort}), ()=>{});
proxyConnection.on('data', data => {
  const message = JSON.parse(data);
  var destinationConnection = destinationConnections[message.id];
  console.log(message)
  if(!destinationConnection){
    if(message.connection){
      return;
    }
    console.log('new clientConnection')
    destinationConnection = destinationConnections[message.id] = net.createConnection(destination.port,destination.hostname,err=>{})
    destinationConnection.setNoDelay(true)
    destinationConnection.on('data',(data)=>{
      console.log('clientData:',data+'')
      proxyConnection.write(JSON.stringify({t:'data',id:message.id,data:data+''})+'\n');
    });
    destinationConnection.on('close',()=>{
      console.log('close')
      try{
        proxyConnection.write(JSON.stringify({t:'close',id:message.id})+'\n');
      }catch(err){}
      delete destinationConnections[message.id];
    })
    destinationConnection.on('error',(err)=>{
      proxyConnection.write(JSON.stringify({t:'error',id:message.id,err})+'\n');
      delete destinationConnections[message.id];
    })
  }
  if(destinationConnection){
    if (message.t === 'data') {
      console.log('message to destination')
      destinationConnection.write(message.data);
    } else if(message.t==='error'){
      destinationConnection.end();
      delete destinationConnections[message.id];
    } else if(message.t==='close'){
      //clientConnection.close();
      destinationConnection.end();
      delete destinationConnections[message.id];
    }
  }
});

